/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables;


import com.tabajara.base.Indexes;
import com.tabajara.base.Keys;
import com.tabajara.base.Public;
import com.tabajara.base.tables.records.ControlegrpacessoRecord;

import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class Controlegrpacesso extends TableImpl<ControlegrpacessoRecord> {

    private static final long serialVersionUID = 1832461256;

    /**
     * The reference instance of <code>public.controlegrpacesso</code>
     */
    public static final Controlegrpacesso CONTROLEGRPACESSO = new Controlegrpacesso();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<ControlegrpacessoRecord> getRecordType() {
        return ControlegrpacessoRecord.class;
    }

    /**
     * The column <code>public.controlegrpacesso.congrpid</code>.
     */
    public final TableField<ControlegrpacessoRecord, Integer> CONGRPID = createField("congrpid", org.jooq.impl.SQLDataType.INTEGER.nullable(false).defaultValue(org.jooq.impl.DSL.field("nextval('controlegrpacesso_congrpid_seq'::regclass)", org.jooq.impl.SQLDataType.INTEGER)), this, "");

    /**
     * The column <code>public.controlegrpacesso.fkconid</code>.
     */
    public final TableField<ControlegrpacessoRecord, Integer> FKCONID = createField("fkconid", org.jooq.impl.SQLDataType.INTEGER, this, "");

    /**
     * The column <code>public.controlegrpacesso.fkgrpid</code>.
     */
    public final TableField<ControlegrpacessoRecord, Integer> FKGRPID = createField("fkgrpid", org.jooq.impl.SQLDataType.INTEGER, this, "");

    /**
     * Create a <code>public.controlegrpacesso</code> table reference
     */
    public Controlegrpacesso() {
        this(DSL.name("controlegrpacesso"), null);
    }

    /**
     * Create an aliased <code>public.controlegrpacesso</code> table reference
     */
    public Controlegrpacesso(String alias) {
        this(DSL.name(alias), CONTROLEGRPACESSO);
    }

    /**
     * Create an aliased <code>public.controlegrpacesso</code> table reference
     */
    public Controlegrpacesso(Name alias) {
        this(alias, CONTROLEGRPACESSO);
    }

    private Controlegrpacesso(Name alias, Table<ControlegrpacessoRecord> aliased) {
        this(alias, aliased, null);
    }

    private Controlegrpacesso(Name alias, Table<ControlegrpacessoRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, "");
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return Public.PUBLIC;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.CONTROLEGRPACESSO_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<ControlegrpacessoRecord, Integer> getIdentity() {
        return Keys.IDENTITY_CONTROLEGRPACESSO;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<ControlegrpacessoRecord> getPrimaryKey() {
        return Keys.CONTROLEGRPACESSO_PKEY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<ControlegrpacessoRecord>> getKeys() {
        return Arrays.<UniqueKey<ControlegrpacessoRecord>>asList(Keys.CONTROLEGRPACESSO_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<ForeignKey<ControlegrpacessoRecord, ?>> getReferences() {
        return Arrays.<ForeignKey<ControlegrpacessoRecord, ?>>asList(Keys.CONTROLEGRPACESSO__CONTROLEGRPACESSO_FKCONID_FKEY, Keys.CONTROLEGRPACESSO__CONTROLEGRPACESSO_FKGRPID_FKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Controlegrpacesso as(String alias) {
        return new Controlegrpacesso(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Controlegrpacesso as(Name alias) {
        return new Controlegrpacesso(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public Controlegrpacesso rename(String name) {
        return new Controlegrpacesso(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public Controlegrpacesso rename(Name name) {
        return new Controlegrpacesso(name, null);
    }
}
